<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/07/2004 *
 * ===================                          Last change: 07/08/2007 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-transfer.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Point transfers between members                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punktetransfers zwischen Mitgliedern             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.2.9');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// Transfer from a member
		addDropTableSql('user_transfers_in');
		addCreateTableSql('user_transfers_in', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`from_userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`points` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`reason` VARCHAR(255) NOT NULL DEFAULT '',
`time_trans` VARCHAR(14) NOT NULL DEFAULT 0,
`trans_id` VARCHAR(12) NOT NULL DEFAULT '',
KEY (`userid`),
KEY (`from_userid`),
PRIMARY KEY (`id`)
) ENGINE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Ingoing points transfers'");

		// Transfers to a member
		addDropTableSql('user_transfers_out');
		addCreateTableSql('user_transfers_out', "(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`to_userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`points` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`reason` VARCHAR(255) NOT NULL DEFAULT '',
`time_trans` VARCHAR(14) NOT NULL DEFAULT 0,
`trans_id` VARCHAR(12) NOT NULL DEFAULT '',
KEY (`userid`),
KEY (`to_userid`),
PRIMARY KEY (`id`)
) ENGINE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci COMMENT = 'Outgoing points transfers'");

		// Admin menu
		addAdminMenuSql('transfer', NULL, '{OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Transfer','Verwalten Sie hier die {OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Transaktionen zwischen Ihren Mitgliedern.', 7);
		addAdminMenuSql('transfer','list_transfer','Auflisten','Hier bekommen Sie alle ein- und ausgehende Transaktionen aufgelistet.', 1);
		addAdminMenuSql('transfer','config_transfer','Einstellungen','Stellen Sie ein, wie viele Transaktionen aufgelistet werden sollen und wie alt diese werden d&uuml;rfen. Die evtl. installierte autopurge-Erweiterung kann dann automatisch die veralteten Transktionen l&ouml;schen.', 2);
		addAdminMenuSql('transfer','del_transfer','Manuell l&ouml;schen','Hier k&ouml;nnen Sie - abgesehen von der automatischen L&ouml;schung - Transaktionen selber l&ouml;schen. Bitte beachten Sie, dass immer aus- und eingehende Transaktionen gleichzeitig gel&ouml;scht werden.', 3);

		// Member menu
		addMemberMenuSql('main', 'transfer', '{OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Transfer', 'N', 'Y', 5);

		// Add config values
		addConfigAddSql('transfer_max', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 50');
		addConfigAddSql('transfer_age', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (getOneDay() * 28));
		addConfigAddSql('transfer_timeout', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT {?ONE_DAY?}');
		addConfigAddSql('transfer_balance', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 100');
		addConfigAddSql('transfer_code', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 5');

		// Add row(s) to user's data
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD opt_in ENUM('Y','N') NOT NULL DEFAULT 'N'");
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('user_transfers_in');
		addDropTableSql('user_transfers_out');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='transfer'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='transfer'");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` DROP `opt_in`");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='transfer' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='transfer' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler <div class=\"notice\">Warning: Missing argument 2 for create_timestamp_from_selections() in {?PATH?}inc/libs/pro_functions.php on line 227</div> behoben.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("&Uuml;berfl&uuml;ssige unset()-Anweisungen aus der what-config_transfer.php entfernt. Dies wird bereits von der eigenen Funktion adminSaveSettings() erledigt.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlende Abfrage im Mitlieder-Modul, on Erweiterung auch aktiviert ist.");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				addConfigAddSql('ap_transfer', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Link <em>Auflisten</em> im Admin-Bereich hatte das eingeloggte Mitglied und nicht den eingeloggten Admin abgefragt. Automatisches L&ouml;schen von veraltete Eintr&auml;gen kann unabh&auml;ngig von der autopurge-Erweiterung de-/aktiviert werden. Bitte aktualisieren Sie auch die beiden Admin-Templates!");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Wegen des Theme-Supportes hat sich die URL zur CSS-Datei ge&auml;ndert.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit E in Transaktionsnummer beseitigt.");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit Speicherung der Einstellungen beseitigt.");
				break;

			case '0.1.0': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Design &quot;Solid-Business&quot; eingebaut.");
				break;

			case '0.1.2': // SQL queries for v0.1.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.1.3': // SQL queries for v0.1.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("IP-Nummer und Browserbezeichnung wird in Admin-Mails eingesetzt.");
				break;

			case '0.1.4': // SQL queries for v0.1.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Link zum Mitgliedsprofil in Funktion <u>generateUserProfileLink()</u> ausgelagert.");
				break;

			case '0.1.5': // SQL queries for v0.1.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Template <u>admin_config_transfer_pro.tpl</u> ist &uuml;berfl&uuml;ssig geworden. Bitte l&ouml;schen Sie dies!");
				break;

			case '0.1.6': // SQL queries for v0.1.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("W&ouml;rter <strong>{?mt_word?}</strong>, <strong>{?mt_word2?}</strong> und <strong>{?mt_word3?}</strong> sind austauschbar.");
				break;

			case '0.1.7': // SQL queries for v0.1.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Wort <strong>Punkte</strong> dynamisiert.");
				break;

			case '0.1.8': // SQL queries for v0.1.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
				break;

			case '0.1.9': // SQL queries for v0.1.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Parser-Error im Mitgliedsbereich beseitigt.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Durchf&uuml;hrung des Transfers korregiert.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sicherheitsupdate f&uuml;r die Include-Befehle.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu_las` (`la_id`, `la_action`, `la_what`) VALUES ('member', '', 'list_transfer')");
				addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu_las` (`la_id`, `la_action`, `la_what`) VALUES ('member', '', 'del_transfer')");
				addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu_las` (`la_id`, `la_action`, `la_what`) VALUES ('config', '', 'config_transfer')");

				// Depends on sql_patches (or you have to execute these both SQL statements by phpMyAdmin
				addExtensionDependency('sql_patches');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erweiterung in's neue Men&uuml;system integriert.");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("<strong>Touring-Code wiederholen</strong> nach <strong>Touring-Code eingeben</strong> hin ge&auml;ndert.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='extras', `sort`=5 WHERE `what`='transfer' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett ge&auml;ndert.");
				break;

			case '0.2.6': // SQL queries for v0.2.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Hash-Erstellung von <strong>md5()</strong> auf bessere Funktion <strong>generateHash()</strong> umgestellt.");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die {?POINTS?} k&ouml;nnen nun wieder wie gewohnt transferiert werden. Der Grund f&uuml;r <em>{--TRANSFER_INVALID_PASSWORD--}</em> war, dass der Cookie-Hash ein anderer ist, als der in der Datenbank... :-/");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlermeldung <em>Notice: Undefined index: to_userid in {?PATH?}/inc/modules/member/what-transfer.php on line 301</em> gefixt. Danke an <a href=\"http://forum.mxchange.org/profile-8.html\" target=\"_blank\" title=\"Forumprofil von Piter01\">Piter01</a>.");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;
		}
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // When extension is initialized
		if ((isResetModeEnabled()) && (getConfig('ap_transfer') == 'Y')) {
			// Automatically remove outdated or not displayed transactions
			autoPurgeTransfers(getConfig('transfer_max'), getConfig('transfer_age'));
		} // END - if
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
}

// [EOF]
?>
